//--------------------------------------------------------------
#define EARTHQUAKE_32_32_16
///////////////////////////

////////////// warnning !!!!!!!!!!!!!
/// we must check whether the message is too large
/// for MPI to broadcast, send/recv
//////////////////////////////////

#define DIMENSIONNUM 4

/////////////////////////////
#ifdef ARGON
    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/ARGON-BUBBLE/histogram"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/ARGON-BUBBLE/clusterIds_bef"

    #define DIMENSIONX 640
    #define DIMENSIONY 256
    #define DIMENSIONZ 256
    #define TIMESTEPS 165

    #define BLOCKDIMX 16
    #define BLOCKDIMY 16
    #define BLOCKDIMZ 16
    #define BLOCKDIMT 1

    #define TIMEWINDOW 11

    #define THRESHOLD 0.25

    #define BINSIZE 128

#elif defined HURRICANE
    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/HURRICANE/20_20_20/histogram"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/HURRICANE/20_20_20/clusterIds"

    #define DIMENSIONX 500
    #define DIMENSIONY 500
    #define DIMENSIONZ 100
    #define TIMESTEPS 48

    #define BLOCKDIMX 20
    #define BLOCKDIMY 20
    #define BLOCKDIMZ 20
    #define BLOCKDIMT 1

    #define TIMEWINDOW 12

    #define THRESHOLD 0.25

    #define BINSIZE 256

#elif defined CLIMATE
    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/CLIMATE/histogram"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/CLIMATE/clusterIds"

    #define DIMENSIONX 360
    #define DIMENSIONY 66
    #define DIMENSIONZ 27
    #define TIMESTEPS 120

    #define BLOCKDIMX 15
    #define BLOCKDIMY 11
    #define BLOCKDIMZ 9
    #define BLOCKDIMT 1

    #define TIMEWINDOW 12

    #define THRESHOLD 0.25

    #define BINSIZE 128

#elif defined CLIMATE_15_11_9
    #define DIMENSIONX 360
    #define DIMENSIONY 66
    #define DIMENSIONZ 27
    #define TIMESTEPS 120

    #define BLOCKDIMX 15
    #define BLOCKDIMY 11
    #define BLOCKDIMZ 9
    #define BLOCKDIMT 1

    #define TIMEWINDOW 12

    #define THRESHOLD 0.25

    #define BINSIZE 128

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/CLIMATE/histogram"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/CLIMATE/15_11_9/clusterIds"

#elif defined COMBUSTION
    #define DIMENSIONX 480
    #define DIMENSIONY 720
    #define DIMENSIONZ 120
    #define TIMESTEPS 122

    #define BLOCKDIMX 30
    #define BLOCKDIMY 15
    #define BLOCKDIMZ 30

    #define BINSIZE 512

    #define BLOCKDIMT 1

    #define TIMEWINDOW 12

    #define THRESHOLD 0.45

    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/COMBUSTION/histogram"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/COMBUSTION/clusterIds_bef"

#elif defined COMBUSTION_20_20_20
    #define DIMENSIONX 480
    #define DIMENSIONY 720
    #define DIMENSIONZ 120
    #define TIMESTEPS 122

    #define BLOCKDIMX 20
    #define BLOCKDIMY 20
    #define BLOCKDIMZ 20

    #define BINSIZE 256

    #define BLOCKDIMT 1

    #define TIMEWINDOW 12

    #define THRESHOLD 0.55

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/COMBUSTION_480_720_120/histogram"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/COMBUSTION_480_720_120/clusterIds_bef"

#elif defined CAMFV
    #define DIMENSIONX 360
    #define DIMENSIONY 180
    #define DIMENSIONZ 30
    #define TIMESTEPS 31

    #define BLOCKDIMX 20
    #define BLOCKDIMY 10
    #define BLOCKDIMZ 5

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.45

    //#define DATAPATH "/media/F0F0A0EDF0A0BAEC/MyData/Climate_netCDF/cam-fv.410/OMEGA_Nor"
    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/Climate_netCDF/cam-fv.410/OMEGA_His_20_10_5"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/Climate_netCDF/cam-fv.410/clusterIds_bef_20_10_5"

#elif defined CAMFV_20_10_5

    #define DIMENSIONX 360
    #define DIMENSIONY 180
    #define DIMENSIONZ 30
    #define TIMESTEPS 31

    #define BLOCKDIMX 20
    #define BLOCKDIMY 10
    #define BLOCKDIMZ 5

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.6

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/CAMFV/BP-normal/histogram"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/CAMFV/20_10_5/clusterIds"

#elif defined CAMSE
    #define DIMENSIONX 512
    #define DIMENSIONY 256
    #define DIMENSIONZ 30
    #define TIMESTEPS 31

    #define BLOCKDIMX 32
    #define BLOCKDIMY 16
    #define BLOCKDIMZ 5

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.45

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/CAMSE/BP-normal/OMEGA_His_32_16_5"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/CAMSE/32_16_5/clusterIds"

#elif defined CAMSE_32_16_5

    #define DIMENSIONX 512
    #define DIMENSIONY 256
    #define DIMENSIONZ 30
    #define TIMESTEPS 31

    #define BLOCKDIMX 32
    #define BLOCKDIMY 16
    #define BLOCKDIMZ 5

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.5

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/CAMSE/BP-normal/OMEGA_His_32_16_5"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/CAMSE/32_16_5/clusterIds"

#elif defined FIM

    #define DIMENSIONX 360
    #define DIMENSIONY 180
    #define DIMENSIONZ 30
    #define TIMESTEPS 31

    #define BLOCKDIMX 20
    #define BLOCKDIMY 10
    #define BLOCKDIMZ 5

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.45
256
    #define DATAPATH "/media/F0F0A0EDF0A0BAEC/MyData/Climate_netCDF/fim.410/OMEGA_Nor"
    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/Climate_netCDF/fim.410/OMEGA_His_20_10_5"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/Climate_netCDF/fim.410/clusterIds_bef_20_10_5"

#elif defined FIM_20_10_5
    #define DIMENSIONX 360
    #define DIMENSIONY 180
    #define DIMENSIONZ 30
    #define TIMESTEPS 31

    #define BLOCKDIMX 20
    #define BLOCKDIMY 10
    #define BLOCKDIMZ 5

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.45

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/FIM/BP-normal/OMEGA_His_20_10_5"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/FIM/20_10_5/clusterIds"

#elif defined EARTHQUAKE

    #define DIMENSIONX 256
    #define DIMENSIONY 256
    #define DIMENSIONZ 96
    #define TIMESTEPS 360

    #define BLOCKDIMX 16
    #define BLOCKDIMY 16
    #define BLOCKDIMZ 16

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.4

    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/EARTHQUAKE/histogram"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/EARTHQUAKE/clusterIds_bef"

#elif defined EARTHQUAKE_16_16_16

    #define DIMENSIONX 256
    #define DIMENSIONY 256
    #define DIMENSIONZ 96
    #define TIMESTEPS 360

    #define BLOCKDIMX 16
    #define BLOCKDIMY 16
    #define BLOCKDIMZ 16

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.4

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/histogram"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/16_16_16/clusterIds"

#elif defined EARTHQUAKE_16_16_8

    #define DIMENSIONX 256
    #define DIMENSIONY 256
    #define DIMENSIONZ 96
    #define TIMESTEPS 360

    #define BLOCKDIMX 16
    #define BLOCKDIMY 16
    #define BLOCKDIMZ 8

    #define BINSIZE 256
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.5

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/16_16_8/histogram"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/16_16_8/clusterIds"

#elif defined EARTHQUAKE_32_32_16
    //#define BIN256
    #define BIN512

    #define DIMENSIONX 256
    #define DIMENSIONY 256
    #define DIMENSIONZ 96
    #define TIMESTEPS 360

    #define BLOCKDIMX 32
    #define BLOCKDIMY 32
    #define BLOCKDIMZ 16

    #define BLOCKDIMT 1
    #define TIMEWINDOW 10

    #ifdef BIN512
        #define BINSIZE 512
        #define THRESHOLD 0.25

        #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/32_32_16/BIN512/histogram"
        #define RESULTPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/32_32_16/BIN512/clusterIds"
    #elif defined BIN256
        #define BINSIZE 256
        #define THRESHOLD 0.25

        #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/32_32_16/BIN256/histogram"
        #define RESULTPATH "/media/D7E456662744A3B7/MyData/EARTHQUAKE/32_32_16/BIN256/clusterIds"
    #endif

#elif defined IONIZATION

    #define DIMENSIONX 600
    #define DIMENSIONY 248
    #define DIMENSIONZ 248
    #define TIMESTEPS 200

    #define BLOCKDIMX 30
    #define BLOCKDIMY 31
    #define BLOCKDIMZ 31

    #define BINSIZE 512
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.3

    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/IONIZATION/histogram"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/IONIZATION/clusterIds_bef"

#elif defined IONIZATION_30_31_31

    #define DIMENSIONX 600
    #define DIMENSIONY 248
    #define DIMENSIONZ 248
    #define TIMESTEPS 200

    #define BLOCKDIMX 30
    #define BLOCKDIMY 31
    #define BLOCKDIMZ 31

    #define BINSIZE 512
    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.3

    #define HISTOGRAMPATH "/media/D7E456662744A3B7/MyData/IONIZATION/histogram"
    #define RESULTPATH "/media/D7E456662744A3B7/MyData/IONIZATION/30_31_31/clusterIds"

#elif defined SUPERNOVA_864

    #define DIMENSIONX 432
    #define DIMENSIONY 432
    #define DIMENSIONZ 432
    #define TIMESTEPS 105

    #define BLOCKDIMX 27
    #define BLOCKDIMY 27
    #define BLOCKDIMZ 27

    #define BINSIZE 128
    #define BLOCKDIMT 1
    #define TIMEWINDOW 15
    #define THRESHOLD 0.5

    #define HISTOGRAMPATH "/media/F0F0A0EDF0A0BAEC/MyData/SUPERNOVA_864_432/histogram"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/SUPERNOVA_864_432/clusterIds_bef"

#elif defined CLOUD

    #define DIMENSIONX 512
    #define DIMENSIONY 512
    #define DIMENSIONZ 512
    #define TIMESTEPS 50

    #define BLOCKDIMX 32
    #define BLOCKDIMY 32
    #define BLOCKDIMZ 32

    #define BINSIZE 64

    #define BLOCKDIMT 1
    #define TIMEWINDOW 10
    #define THRESHOLD 0.5

    #define HISTOGRAMPATH "/med0ia/F0F0A0EDF0A0BAEC/MyData/CLOUD/histogram"
    #define RESULTPATH "/media/F0F0A0EDF0A0BAEC/MyData/CLOUD/clusterIds_bef"

#endif

#define ZERO 0.000001

#define MASTER 0

///////// Section breaker *********
///////////// calculate block number in each dimension
int BLOCKNUMX = DIMENSIONX / BLOCKDIMX;
int BLOCKNUMY = DIMENSIONY / BLOCKDIMY;
int BLOCKNUMZ = DIMENSIONZ / BLOCKDIMZ;
int BLOCKNUMT = TIMESTEPS / BLOCKDIMT;

// To save duplicate calculations
int BLOCKNUMXY = BLOCKNUMX * BLOCKNUMY;
int BLOCKNUMXYZ = BLOCKNUMXY * BLOCKNUMZ;
int BLOCKNUMXYZW = BLOCKNUMXYZ * TIMEWINDOW;
int BLOCKNUMXYZB = BLOCKNUMXYZ * BINSIZE;

double totalTime_t;
double loading_t;
double computing_t;
double broadcast_t;
double sendrecv_t;
double saving_t;

double regionGrowing_t;

double totalstart_t;
double totalend_t;
double start_t;
double end_t;
double temp_start_t;
double temp_end_t;

double mylog2 = log(2.0);
float oneoverlog2 = 1.0f / mylog2;
float halfoneoverlog2 = 0.5f * oneoverlog2;

float avgHis[BINSIZE];

/// A struct that consists of the information
/// of a block
/// t: the time step that the block locates in
/// lindex: the index of the block at that time step
/// similar: the similarity of this block with the target
/// his[BINSIZE]: the histogram of the block
struct blockInfo{
    int t;
    int lindex;
    bool similar;
    float his[BINSIZE];
};

/// A structure that stores the ID information of a block
/// t: the time step that the block locates in
/// lindex: the index of the block at that time step
/// gid: the global id
struct blockInGroup{
    int t;
    int lindex;

    int gid;
};


